export function format(data: string, indentChar?: string, indentBase?: string){
	indentChar = indentChar ? indentChar : "\t";
	indentBase = indentBase ? indentBase : "";

	let formattedJSON = "";
	let dataObject = undefined;
	try{
		dataObject = JSON.parse(data);
	} catch(Error){
		throw new TypeError("data parameter is not a valid JSON string !");
		return;
	}
	let dataIsArray = JSONtypeOf(dataObject) == "array";

	// OPEN
	if(dataIsArray){
		if(data.length == 0) // Test empty array case
			return "[]";
		formattedJSON = "[";
	}else{
		let objectsCount = 0;
		for(let obj in dataObject){
			objectsCount++;
			break;
		}
		if(objectsCount == 0) // Test empty object case
			return "{}";
		formattedJSON = "{";
	}
	// CONTENT
	let objectsCount = 0;
	let keys = Object.keys(dataObject);
	for(let keyID = 0; keyID < keys.length; ++keyID){
		if(objectsCount > 0)
			formattedJSON += ",";
		if(dataIsArray)
			formattedJSON += `\n${indentBase}${indentChar}`
		else
			formattedJSON += `\n${indentBase}${indentChar}"${keys[keyID]}": `;

		switch(JSONtypeOf(dataObject[keys[keyID]])){
			case "array":
			case "object":
				formattedJSON += format(JSON.stringify(dataObject[keys[keyID]]), indentChar, indentBase + indentChar);
				break;
			case "number":
				formattedJSON += dataObject[keys[keyID]].toString();
				break;
			case "null":
				formattedJSON += "null";
				break;
			case "string":
				formattedJSON += `"${dataObject[keys[keyID]]}"`;
				break;
			case "boolean":
				formattedJSON += dataObject[keys[keyID]];
				break;
		}
		objectsCount++;
	}

	// CLOSE
	if(dataIsArray)
		formattedJSON += `\n${indentBase}]`;
	else
		formattedJSON += `\n${indentBase}}`;

	return formattedJSON;
}

function JSONtypeOf(obj) {
	let typeOf = typeof(obj);
	if (typeOf == "object") {
		if (obj === null) return "null";
		if (Array.isArray(obj)) return "array";
		return "object";
	}
	return typeOf;
}
